
package net.mcreator.expandicraft.fluid;

import net.minecraftforge.fluids.ForgeFlowingFluid;

import net.minecraft.world.level.material.FluidState;
import net.minecraft.world.level.material.Fluid;
import net.minecraft.world.level.block.state.StateDefinition;
import net.minecraft.world.level.block.LiquidBlock;

import net.mcreator.expandicraft.init.ExpandiCraftModItems;
import net.mcreator.expandicraft.init.ExpandiCraftModFluids;
import net.mcreator.expandicraft.init.ExpandiCraftModFluidTypes;
import net.mcreator.expandicraft.init.ExpandiCraftModBlocks;

public abstract class VoidwaterFluid extends ForgeFlowingFluid {
	public static final ForgeFlowingFluid.Properties PROPERTIES = new ForgeFlowingFluid.Properties(() -> ExpandiCraftModFluidTypes.VOIDWATER_TYPE.get(), () -> ExpandiCraftModFluids.VOIDWATER.get(), () -> ExpandiCraftModFluids.FLOWING_VOIDWATER.get())
			.explosionResistance(100f).bucket(() -> ExpandiCraftModItems.VOIDWATER_BUCKET.get()).block(() -> (LiquidBlock) ExpandiCraftModBlocks.VOIDWATER.get());

	private VoidwaterFluid() {
		super(PROPERTIES);
	}

	public static class Source extends VoidwaterFluid {
		public int getAmount(FluidState state) {
			return 8;
		}

		public boolean isSource(FluidState state) {
			return true;
		}
	}

	public static class Flowing extends VoidwaterFluid {
		protected void createFluidStateDefinition(StateDefinition.Builder<Fluid, FluidState> builder) {
			super.createFluidStateDefinition(builder);
			builder.add(LEVEL);
		}

		public int getAmount(FluidState state) {
			return state.getValue(LEVEL);
		}

		public boolean isSource(FluidState state) {
			return false;
		}
	}
}
